Arch Frame
THIS COMMAND IS PART OF THE INTEGRATED BIM WORKBENCH IN V1.0
This page has been updated for that version.
This page has been updated for that version.
|
Menu location |
---|
3D/BIM → Frame |
Workbenches |
BIM |
Default shortcut |
F R |
Introduced in version |
- |
See also |
None |
Description
The Arch Frame tool is used to build all kinds of frame objects based on a profile and a layout. The profile is extruded along the edges of the layout, which can be any 2D object such as a sketch, or a Draft object. It is especially useful to create railings, or frame walls. Frame objects can then easily be turned into wall or structure objects.
Frame object created from a Draft OrthoArray of a Draft Line, using a Draft Circle as profile
Usage
- Create a layout object and a profile object, for example with the Draft Workbench or the Sketcher Workbench.
- Select the layout object first, then, with Ctrl pressed, select the profile object.
- Press the
Frame button, or press F then R keys.
Options
- Frames share the common properties and behaviours of all Arch Components
- The frame object can be placed at a certain distance from the layout object, by setting its Offset property
- The profile will be copied at the base of each edge of the layout object, then extruded along it. You can control how the profile is placed at the base of each edge with the Align and Rotation properties.
Properties
Data
Component
- DataBase (
Link
): The layout this frame is based on.
For the other properties in the group see Arch Component.
Frame
- DataAlign (
Bool
): Specifies if the profile must be rotated to have its normal axis aligned with each edge. - DataBase Point (
Integer
): Zero-based index indicating the crossing point of the path on the profile:0
: The Base of the Placement of the profile. This point is also used in case of an invalid index.1
: The midpoint of the 1st edge of the profile.2
: The endpoint of the 1st edge of the profile.3
: The midpoint of the 2nd edge of the profile.4
: The endpoint of the 2nd edge of the profile.- ...
n*2-1
: The midpoint of the nth edge of the profile.n*2
: The endpoint of the nth edge of the profile.
- DataEdges (
Enumeration
): The type of edges to consider. The options are:All edges
Vertical edges
Horizontal edges
Bottom horizontal edges
: Based of the global Z coordinate of the center of mass of the edge.Top horizontal edges
: Idem.
- DataFuse (
Bool
): If true, overlapping solids are fused. - DataOffset (
VectorDistance
): An optional distance between the layout object and the frame object. - DataProfile (
Link
): The profile this frame is based on. - DataProfile Placement (
Placement
): An optional additional placement to add to the profile before extruding it. Only the Rotation of the Placement is used. Ignored if DataAlign istrue
. - DataRotation (
Angle
): The rotation of the profile around its extrusion axis.
Scripting
See also: Arch API and FreeCAD Scripting Basics.
The Frame tool can be used in macros and from the Python console by using the following function:
Frame = makeFrame(baseobj, profile)
- Creates a
Frame
object from the givenbaseobj
andprofile
.baseobj
is any object containing wires, like a Draft Wire, or a Draft OrthoArray with a collection of them.profile
is an extrudable 2D object containing faces or closed wires.
Example:
import Draft, Arch
Line = Draft.makeLine(FreeCAD.Vector(0, 0, 0), FreeCAD.Vector(0, 0, 2000))
baseobj = Draft.makeArray(Line, FreeCAD.Vector(1000, 0, 0), FreeCAD.Vector(0, 1, 0), 6, 1)
profile = Draft.makeCircle(200)
Frame = Arch.makeFrame(baseobj, profile)
FreeCAD.ActiveDocument.recompute()
- 2D drafting: Sketch, Line, Polyline, Circle, Arc, Arc by 3 points, Fillet, Ellipse, Polygon, Rectangle, B-spline, Bézier curve, Cubic Bézier curve, Point
- 3D/BIM: Project, Site, Building, Level, Space, Wall, Curtain Wall, Column, Beam, Slab, Door, Window, Pipe, Pipe Connector, Stairs, Roof, Panel, Frame, Fence, Truss, Equipment
- Reinforcement tools: Custom Rebar, Straight Rebar, U-Shape Rebar, L-Shape Rebar, Stirrup, Bent-Shape Rebar, Helical Rebar, Column Reinforcement, Beam Reinforcement, Slab Reinforcement, Footing Reinforcement
- Generic 3D tools: Profile, Box, Shape builder..., Facebinder, Objects library, Component, External reference
- Annotation: Text, Shape from text, Aligned dimension, Horizontal dimension, Vertical dimension, Leader, Label, Axis, Axes System, Grid, Section Plane, Hatch, Page, View, Shape-based view
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid, Working Plane Top, Working Plane Front, Working Plane Side
- Modify: Move, Copy, Rotate, Clone, Create simple copy, Make compound, Offset, 2D Offset..., Trimex, Join, Split, Scale, Stretch, Draft to sketch, Upgrade, Downgrade, Add component, Remove component, Array, Path array, Polar array, Point array, Cut with plane, Mirror, Extrude..., Difference, Union, Intersection
- Manage: BIM Setup..., Views manager, Manage project..., Manage doors and windows..., Manage IFC elements..., Manage IFC quantities..., Manage IFC properties..., Manage classification..., Manage layers..., Material, Schedule, Preflight checks..., Annotation styles...
- Utils: Toggle bottom panels, Move to Trash, Working Plane View, Select group, Set slope, Create working plane proxy, Add to construction group, Split Mesh, Mesh to Shape, Select non-manifold meshes, Remove Shape from Arch, Close Holes, Merge Walls, Check, Toggle IFC Brep flag, Toggle subcomponents, Survey, IFC Diff, IFC explorer, Create IFC spreadsheet..., Image plane, Unclone, Rewire, Glue, Reextrude
- Panel tools: Panel, Panel Cut, Panel Sheet, Nest
- Structure tools: Structure, Structural System, Multiple Structures
- IFC tools: IFC Diff..., IFC Expand, Make IFC project, IfcOpenShell update
- Nudge: Nudge Switch, Nudge Up, Nudge Down, Nudge Left, Nudge Right, Nudge Rotate Left, Nudge Rotate Right, Nudge Extend, Nudge Shrink
- Additional: Preferences, Fine tuning, Import Export Preferences, IFC, DAE, OBJ, JSON, 3DS, SHP

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub